#ifndef INTERFACE_CHANNEL_HPP_
#define INTERFACE_CHANNEL_HPP_
#include <includes.hpp>
#include <network.hpp>
class Channel {
private:
    const nlohmann::json& data;
    WebSocket& web;
    NetworkManager& req;
public:
    Channel(const nlohmann::json& data) : data(data), web(WebSocket::getInstance()), req(NetworkManager::getInstance()) {}
    std::string send(const nlohmann::json& msg) {
        return req.request(HttpMethods::POST, DiscordEndpoints::details::latest + "/channels/" + data["d"]["channel_id"].get<std::string>() + "/messages", msg.dump());
    }
};
#endif