#ifndef TLS_NETWORK_HPP_
#define TLS_NETWORK_HPP_
#include <includes.hpp>
#include <network/websocket.hpp>
#include <curl/curl.h>
class NetworkManager {
private:
    CURL* curl;
    CURLcode res;
    WebSocket& web;
    auto operator=(const NetworkManager&) -> NetworkManager& = delete;
    auto operator=(NetworkManager&&) -> NetworkManager& = delete;
    NetworkManager(NetworkManager&&) = delete;
    NetworkManager(const NetworkManager&) = delete;
    NetworkManager();
    ~NetworkManager();
    static auto WriteCallback(void* contents, unsigned long size, unsigned long nmemb, void* userp) -> unsigned long;
public:
    static auto getInstance() -> NetworkManager&;
    [[nodiscard]] auto getLatency() const -> unsigned long;
    auto request(const std::string& method, const std::string& path, const std::string& data = "") -> std::string;
};
#endif